# Snapshot report for `test/function.js`

The actual snapshot is saved in `function.js.snap`.

Generated by [AVA](https://avajs.dev).

## assign-properties-to-default-export

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      const foo = {};␊
      ␊
      var foo_1 = foo;␊
      var bar = 1;␊
      var baz = 2;␊
      foo_1.bar = bar;␊
      foo_1.baz = baz;␊
      ␊
      t.is(foo_1.bar, 1);␊
      t.is(foo_1.baz, 2);␊
      `,
    }

## assumed-globals

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var document_1 = createCommonjsModule(function (module) {␊
      /* eslint-disable */␊
      if (typeof document !== 'undefined') {␊
        module.exports = document;␊
      } else {␊
        module.exports = { fake: true };␊
      }␊
      });␊
      ␊
      t.deepEqual(document_1, { real: true });␊
      `,
    }

## bare-import

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      Math.bar = 42;␊
      ␊
      t.is(Math.bar, 42);␊
      `,
    }

## bare-import-comment

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      // Great module␊
      Math.bar = 42;␊
      ␊
      t.is(Math.bar, 42);␊
      `,
    }

## basic

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var foo = 21;␊
      ␊
      var main = foo * 2;␊
      ␊
      module.exports = main;␊
      `,
    }

## dash-name

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var dashName = true;␊
      ␊
      t.truthy(dashName);␊
      `,
    }

## deconflict-export-and-local

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var someValue_1 = 10;␊
      ␊
      var someValue = {␊
      	someValue: someValue_1␊
      };␊
      ␊
      var someValue$1 = someValue.someValue;␊
      ␊
      t.is(someValue$1, 10);␊
      `,
    }

## dot

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var foo_bar = 'fubar';␊
      ␊
      t.is(foo_bar, 'fubar');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## duplicate-default-exports

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      const x = {};␊
      ␊
      var x_1 = x;␊
      var _default = x;␊
      x_1.default = _default;␊
      ␊
      t.is(x_1.default, x_1);␊
      `,
    }

## duplicate-default-exports-b

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      const x = {};␊
      ␊
      var x_1 = x;␊
      var _default = 42;␊
      x_1.default = _default;␊
      ␊
      t.deepEqual(x_1, { default: 42 });␊
      `,
    }

## duplicate-default-exports-c

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var Foo = 1;␊
      var _var = 'VAR';␊
      var _default = {␊
        Foo: 2,␊
        default: 3␊
      };␊
      ␊
      var exports$1 = {␊
      	Foo: Foo,␊
      	var: _var,␊
      	default: _default␊
      };␊
      ␊
      /* eslint-disable */␊
      ␊
      t.is(exports$1.Foo, 1);␊
      t.is(exports$1.var, 'VAR');␊
      t.deepEqual(exports$1.default, { Foo: 2, default: 3 });␊
      t.is(exports$1.default.Foo, 2);␊
      t.is(exports$1.default.default, 3);␊
      t.is(Foo, 1);␊
      t.is(_var, 'VAR');␊
      `,
    }

## dynamic-module-require

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-module-require/submodule.js", function (module, exports) {␊
        module.exports = function() {␊
        return 'Hello there';␊
      };␊
      ␊
      });␊
      ␊
      var main = createCommonjsModule(function (module) {␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      let message;␊
      ␊
      function takeModule(withName) {␊
        return module.require(`./${withName}`);␊
      }␊
      ␊
      try {␊
        const submodule = takeModule('submodule');␊
        message = submodule();␊
      } catch (err) {␊
        ({ message } = err);␊
      }␊
      ␊
      t.is(message, 'Hello there');␊
      }, "/$$rollup_base$$/fixtures/function/dynamic-module-require");␊
      ␊
      module.exports = main;␊
      `,
    }

## dynamic-require

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require/submodule.js", function (module, exports) {␊
        module.exports = function() {␊
        return 'Hello there';␊
      };␊
      ␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      let message;␊
      ␊
      function takeModule(withName) {␊
        return commonjsRequire(`./${withName}`,"/$$rollup_base$$/fixtures/function/dynamic-require");␊
      }␊
      ␊
      try {␊
        const submodule = takeModule('submodule');␊
        message = submodule();␊
      } catch (err) {␊
        ({ message } = err);␊
      }␊
      ␊
      t.is(message, 'Hello there');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## dynamic-require-absolute-import

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-absolute-import/sub/node_modules/module/direct.js", function (module, exports) {␊
        module.exports = 'direct';␊
      ␊
      });␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-absolute-import/sub/node_modules/module/nested/nested.js", function (module, exports) {␊
        module.exports = 'nested';␊
      ␊
      });␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-absolute-import/node_modules/parent-module/parent.js", function (module, exports) {␊
        module.exports = 'parent';␊
      ␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModule(name) {␊
        return commonjsRequire(name,"/$$rollup_base$$/fixtures/function/dynamic-require-absolute-import/sub");␊
      }␊
      ␊
      var moduleDirect = takeModule('module/direct');␊
      var moduleNested = takeModule('module/nested/nested');␊
      var parentModule = takeModule('parent-module/parent');␊
      ␊
      var submodule = {␊
      	moduleDirect: moduleDirect,␊
      	moduleNested: moduleNested,␊
      	parentModule: parentModule␊
      };␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      t.deepEqual(submodule, {␊
        moduleDirect: 'direct',␊
        moduleNested: 'nested',␊
        parentModule: 'parent'␊
      });␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## dynamic-require-absolute-paths

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }␊
      ␊
      var Path = _interopDefault(require('path'));␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-absolute-paths/submodule.js", function (module, exports) {␊
        module.exports = 'submodule';␊
      ␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      ␊
      ␊
      const basePath = `${process.cwd()}/fixtures/function/dynamic-require-absolute-paths`;␊
      ␊
      t.is(commonjsRequire(Path.resolve(`${basePath}/submodule.js`),"/$$rollup_base$$/fixtures/function/dynamic-require-absolute-paths"), 'submodule');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## dynamic-require-code-splitting

> Snapshot 1

    {
      'lib2-9ad56b7a.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-code-splitting/target1.js", function (module, exports) {␊
        module.exports = '1';␊
      ␊
      });␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-code-splitting/target2.js", function (module, exports) {␊
        module.exports = '2';␊
      ␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      let message;␊
      ␊
      for (const index of [1, 2]) {␊
        try {␊
          message = commonjsRequire(`./target${index}.js`,"/$$rollup_base$$/fixtures/function/dynamic-require-code-splitting");␊
        } catch (err) {␊
          ({ message } = err);␊
        }␊
        t.is(message, index.toString());␊
      }␊
      ␊
      exports.commonjsRequire = commonjsRequire;␊
      `,
      'main.js': `'use strict';␊
      ␊
      var lib2 = require('./lib2-9ad56b7a.js');␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      let message;␊
      ␊
      for (const index of [1, 2]) {␊
        try {␊
          message = lib2.commonjsRequire(`./target${index}.js`,"/$$rollup_base$$/fixtures/function/dynamic-require-code-splitting");␊
        } catch (err) {␊
          ({ message } = err);␊
        }␊
        t.is(message, index.toString());␊
      }␊
      `,
      'main2.js': `'use strict';␊
      ␊
      require('./lib2-9ad56b7a.js');␊
      ␊
      `,
    }

## dynamic-require-es-entry

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-es-entry/submodule.js", function (module, exports) {␊
        module.exports = 'submodule';␊
      ␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModule(withName) {␊
        return commonjsRequire(`./${withName}`,"/$$rollup_base$$/fixtures/function/dynamic-require-es-entry");␊
      }␊
      ␊
      var importer = takeModule('submodule.js');␊
      ␊
      t.is(importer, 'submodule');␊
      `,
    }

## dynamic-require-extensions

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-extensions/submodule.js", function (module, exports) {␊
        module.exports = { name: 'submodule', value: null };␊
      ␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModule(withName) {␊
        return commonjsRequire(`./${withName}`,"/$$rollup_base$$/fixtures/function/dynamic-require-extensions");␊
      }␊
      ␊
      const withExtension = takeModule('submodule.js');␊
      const withoutExtension = takeModule('submodule');␊
      ␊
      t.is(withExtension.name, 'submodule');␊
      t.is(withoutExtension.name, 'submodule');␊
      ␊
      withExtension.value = 'mutated';␊
      ␊
      t.is(withoutExtension.value, 'mutated');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## dynamic-require-globs

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-globs/submodule1.js", function (module, exports) {␊
        module.exports = 'submodule1';␊
      ␊
      });␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-globs/submodule2.js", function (module, exports) {␊
        module.exports = 'submodule2';␊
      ␊
      });␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-globs/extramodule1.js", function (module, exports) {␊
        module.exports = 'extramodule1';␊
      ␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModule(withName) {␊
        return commonjsRequire(`./${withName}`,"/$$rollup_base$$/fixtures/function/dynamic-require-globs");␊
      }␊
      ␊
      t.is(takeModule('submodule1.js'), 'submodule1');␊
      t.is(takeModule('submodule2.js'), 'submodule2');␊
      t.is(takeModule('extramodule1.js'), 'extramodule1');␊
      ␊
      let hasThrown = false;␊
      try {␊
        takeModule('extramodule2.js');␊
      } catch (error) {␊
        t.truthy(/Cannot find module '\\.\\/extramodule2\\.js'/.test(error.message));␊
        hasThrown = true;␊
      }␊
      t.truthy(hasThrown);␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## dynamic-require-instances

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-instances/direct/index.js", function (module, exports) {␊
        module.exports = { name: 'direct', value: null };␊
      ␊
      });␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-instances/package/main.js", function (module, exports) {␊
        module.exorts = { name: 'package', value: null };␊
      ␊
      });␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-instances/direct", function (module, exports) {␊
        module.exports = commonjsRequire("/$$rollup_base$$/fixtures/function/dynamic-require-instances/direct/index.js", null);␊
      });␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-instances/package", function (module, exports) {␊
        module.exports = commonjsRequire("/$$rollup_base$$/fixtures/function/dynamic-require-instances/package/main.js", null);␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModule(withName) {␊
        return commonjsRequire(withName,"/$$rollup_base$$/fixtures/function/dynamic-require-instances");␊
      }␊
      ␊
      takeModule('./direct').value = 'direct-instance';␊
      t.is(takeModule('./direct/index.js').value, 'direct-instance');␊
      t.is(commonjsRequire("./direct/index.js", "/$$rollup_base$$/fixtures/function/dynamic-require-instances").value, 'direct-instance');␊
      ␊
      takeModule('./package').value = 'package-instance';␊
      t.is(takeModule('./package/main.js').value, 'package-instance');␊
      t.is(commonjsRequire("./package/main.js", "/$$rollup_base$$/fixtures/function/dynamic-require-instances").value, 'package-instance');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## dynamic-require-json

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      var value = "present";␊
      var require$$0 = {␊
      	value: value␊
      };␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-json/dynamic.json", function (module, exports) {␊
        module.exports = require$$0;␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModule(withName) {␊
        return commonjsRequire(`./${withName}`,"/$$rollup_base$$/fixtures/function/dynamic-require-json");␊
      }␊
      ␊
      t.deepEqual(takeModule('dynamic.json'), { value: 'present' });␊
      t.deepEqual(takeModule('dynamic'), { value: 'present' });␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## dynamic-require-package

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      var entry = 'same-directory';␊
      ␊
      var entry$1 = 'sub';␊
      ␊
      var entry$2 = 'custom-module';␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-package", function (module, exports) {␊
        module.exports = entry;␊
      });␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-package/sub", function (module, exports) {␊
        module.exports = entry$1;␊
      });␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-package/node_modules/custom-module", function (module, exports) {␊
        module.exports = entry$2;␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModule(name) {␊
        return commonjsRequire(name,"/$$rollup_base$$/fixtures/function/dynamic-require-package/sub");␊
      }␊
      ␊
      var sub = {␊
        parent: takeModule('..'),␊
        customModule: takeModule('custom-module')␊
      };␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModule$1(name) {␊
        return commonjsRequire(name,"/$$rollup_base$$/fixtures/function/dynamic-require-package");␊
      }␊
      ␊
      t.is(takeModule$1('.'), 'same-directory');␊
      t.is(takeModule$1('./'), 'same-directory');␊
      t.is(takeModule$1('.//'), 'same-directory');␊
      ␊
      t.is(takeModule$1('./sub'), 'sub');␊
      ␊
      t.is(takeModule$1('custom-module'), 'custom-module');␊
      t.deepEqual(sub, { parent: 'same-directory', customModule: 'custom-module' });␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## dynamic-require-package-sub

> Snapshot 1

    {
      'entry.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-package-sub/node_modules/custom-module/entry.js", function (module, exports) {␊
        module.exports = 'custom-module';␊
      ␊
      });␊
      ␊
      var main = "./entry.js";␊
      var require$$0 = {␊
      	main: main␊
      };␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-package-sub/node_modules/custom-module/package.json", function (module, exports) {␊
        module.exports = require$$0;␊
      });␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-package-sub/node_modules/custom-module", function (module, exports) {␊
        module.exports = commonjsRequire("/$$rollup_base$$/fixtures/function/dynamic-require-package-sub/node_modules/custom-module/entry.js", null);␊
      });␊
      ␊
      t.is(commonjsRequire("custom-module", "/$$rollup_base$$/fixtures/function/dynamic-require-package-sub/sub"), 'custom-module');␊
      ␊
      var entry = {␊
      ␊
      };␊
      ␊
      module.exports = entry;␊
      `,
    }

## dynamic-require-relative-paths

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-relative-paths/sub/submodule.js", function (module, exports) {␊
        module.exports = 'submodule';␊
      ␊
      });␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-relative-paths/sub/subsub/subsubmodule.js", function (module, exports) {␊
        module.exports = 'subsubmodule';␊
      ␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModuleWithDelimiter(name, delimiter) {␊
        return commonjsRequire(`.${delimiter}${name.replace(/=/g, delimiter)}`,"/$$rollup_base$$/fixtures/function/dynamic-require-relative-paths");␊
      }␊
      ␊
      t.is(takeModuleWithDelimiter('sub=submodule.js', '/'), 'submodule');␊
      t.is(takeModuleWithDelimiter('sub=subsub=subsubmodule.js', '/'), 'subsubmodule');␊
      t.is(takeModuleWithDelimiter('sub=submodule.js', '\\\\'), 'submodule');␊
      t.is(takeModuleWithDelimiter('sub=subsub=subsubmodule.js', '\\\\'), 'subsubmodule');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## dynamic-require-resolve-index

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function commonjsRegister (path, loader) {␊
      	DYNAMIC_REQUIRE_LOADERS[path] = loader;␊
      }␊
      ␊
      const DYNAMIC_REQUIRE_LOADERS = Object.create(null);␊
      const DYNAMIC_REQUIRE_CACHE = Object.create(null);␊
      const DEFAULT_PARENT_MODULE = {␊
      	id: '<' + 'rollup>', exports: {}, parent: undefined, filename: null, loaded: false, children: [], paths: []␊
      };␊
      const CHECKED_EXTENSIONS = ['', '.js', '.json'];␊
      ␊
      function normalize (path) {␊
      	path = path.replace(/\\\\/g, '/');␊
      	const parts = path.split('/');␊
      	const slashed = parts[0] === '';␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] === '.' || parts[i] === '') {␊
      			parts.splice(i--, 1);␊
      		}␊
      	}␊
      	for (let i = 1; i < parts.length; i++) {␊
      		if (parts[i] !== '..') continue;␊
      		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {␊
      			parts.splice(--i, 2);␊
      			i--;␊
      		}␊
      	}␊
      	path = parts.join('/');␊
      	if (slashed && path[0] !== '/')␊
      	  path = '/' + path;␊
      	else if (path.length === 0)␊
      	  path = '.';␊
      	return path;␊
      }␊
      ␊
      function join () {␊
      	if (arguments.length === 0)␊
      	  return '.';␊
      	let joined;␊
      	for (let i = 0; i < arguments.length; ++i) {␊
      	  let arg = arguments[i];␊
      	  if (arg.length > 0) {␊
      		if (joined === undefined)␊
      		  joined = arg;␊
      		else␊
      		  joined += '/' + arg;␊
      	  }␊
      	}␊
      	if (joined === undefined)␊
      	  return '.';␊
      ␊
      	return joined;␊
      }␊
      ␊
      function isPossibleNodeModulesPath (modulePath) {␊
      	let c0 = modulePath[0];␊
      	if (c0 === '/' || c0 === '\\\\') return false;␊
      	let c1 = modulePath[1], c2 = modulePath[2];␊
      	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\\\')) ||␊
      		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\\\'))) return false;␊
      	if (c1 === ':' && (c2 === '/' || c2 === '\\\\'))␊
      		return false;␊
      	return true;␊
      }␊
      ␊
      function dirname (path) {␊
        if (path.length === 0)␊
          return '.';␊
      ␊
        let i = path.length - 1;␊
        while (i > 0) {␊
          const c = path.charCodeAt(i);␊
          if ((c === 47 || c === 92) && i !== path.length - 1)␊
            break;␊
          i--;␊
        }␊
      ␊
        if (i > 0)␊
          return path.substr(0, i);␊
      ␊
        if (path.chartCodeAt(0) === 47 || path.chartCodeAt(0) === 92)␊
          return path.charAt(0);␊
      ␊
        return '.';␊
      }␊
      ␊
      function commonjsRequire (path, originalModuleDir) {␊
      	const shouldTryNodeModules = isPossibleNodeModulesPath(path);␊
      	path = normalize(path);␊
      	let relPath;␊
      	while (true) {␊
      		if (!shouldTryNodeModules) {␊
      			relPath = originalModuleDir ? normalize(originalModuleDir + '/' + path) : path;␊
      		} else if (originalModuleDir) {␊
      			relPath = normalize(originalModuleDir + '/node_modules/' + path);␊
      		} else {␊
      			relPath = normalize(join('node_modules', path));␊
      		}␊
      		for (let extensionIndex = 0; extensionIndex < CHECKED_EXTENSIONS.length; extensionIndex++) {␊
      			const resolvedPath = relPath + CHECKED_EXTENSIONS[extensionIndex];␊
      			let cachedModule = DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      			if (cachedModule) return cachedModule.exports;␊
      			const loader = DYNAMIC_REQUIRE_LOADERS[resolvedPath];␊
      			if (loader) {␊
      				DYNAMIC_REQUIRE_CACHE[resolvedPath] = cachedModule = {␊
      					id: resolvedPath,␊
      					filename: resolvedPath,␊
      					path: dirname(resolvedPath),␊
      					exports: {},␊
      					parent: DEFAULT_PARENT_MODULE,␊
      					loaded: false,␊
      					children: [],␊
      					paths: [],␊
      					require: function (path, base) {␊
      					  return commonjsRequire(path, (base === undefined || base === null) ? cachedModule.path : base);␊
      					}␊
      				};␊
      				try {␊
      					loader.call(commonjsGlobal, cachedModule, cachedModule.exports);␊
      				} catch (error) {␊
      					delete DYNAMIC_REQUIRE_CACHE[resolvedPath];␊
      					throw error;␊
      				}␊
      				cachedModule.loaded = true;␊
      				return cachedModule.exports;␊
      			}		}␊
      		if (!shouldTryNodeModules) break;␊
      		const nextDir = normalize(originalModuleDir + '/..');␊
      		if (nextDir === originalModuleDir) break;␊
      		originalModuleDir = nextDir;␊
      	}␊
      	return require(path);␊
      }␊
      ␊
      commonjsRequire.cache = DYNAMIC_REQUIRE_CACHE;␊
      ␊
      var dynamicRequireResolveIndex = 'same-directory';␊
      ␊
      var sub = 'sub';␊
      ␊
      var customModule = 'custom-module';␊
      ␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-resolve-index", function (module, exports) {␊
        module.exports = dynamicRequireResolveIndex;␊
      });␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-resolve-index/sub", function (module, exports) {␊
        module.exports = sub;␊
      });␊
      commonjsRegister("/$$rollup_base$$/fixtures/function/dynamic-require-resolve-index/node_modules/custom-module", function (module, exports) {␊
        module.exports = customModule;␊
      });␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModule(name) {␊
        return commonjsRequire(name,"/$$rollup_base$$/fixtures/function/dynamic-require-resolve-index/sub");␊
      }␊
      ␊
      var sub$1 = {␊
        parent: takeModule('..'),␊
        customModule: takeModule('custom-module')␊
      };␊
      ␊
      /* eslint-disable import/no-dynamic-require, global-require */␊
      ␊
      function takeModule$1(name) {␊
        return commonjsRequire(name,"/$$rollup_base$$/fixtures/function/dynamic-require-resolve-index");␊
      }␊
      ␊
      t.is(takeModule$1('.'), 'same-directory');␊
      t.is(takeModule$1('./'), 'same-directory');␊
      t.is(takeModule$1('.//'), 'same-directory');␊
      ␊
      t.is(takeModule$1('./sub'), 'sub');␊
      ␊
      t.is(takeModule$1('custom-module'), 'custom-module');␊
      t.deepEqual(sub$1, { parent: 'same-directory', customModule: 'custom-module' });␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## es6-export-with-global-sniffing

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      let root;␊
      ␊
      if (typeof self !== 'undefined') {␊
        root = self;␊
      } else if (typeof window !== 'undefined') {␊
        root = window;␊
      } else if (typeof global !== 'undefined') {␊
        root = global;␊
      } else {␊
        root = module;␊
      }␊
      ␊
      root.pollution = 'foo';␊
      ␊
      const getGlobalPollution = () => 'foo';␊
      ␊
      // this test makes sure that "submodule" is not wrapped in commonjs␊
      ␊
      t.is(getGlobalPollution(), global.pollution);␊
      `,
    }

## esm-externals-false

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }␊
      ␊
      var externalExports = _interopDefault(require('external-cjs-exports'));␊
      var externalModuleExports = _interopDefault(require('external-cjs-module-exports'));␊
      var externalNamed = _interopDefault(require('external-esm-named'));␊
      var externalMixed = _interopDefault(require('external-esm-mixed'));␊
      var externalDefault = _interopDefault(require('external-esm-default'));␊
      ␊
      t.deepEqual(externalExports, { foo: 'foo' }, 'external exports');␊
      t.deepEqual(externalModuleExports, 'bar', 'external module exports');␊
      t.deepEqual(externalNamed, { foo: 'foo' }, 'external named');␊
      t.deepEqual(externalMixed, 'bar', 'external mixed');␊
      t.deepEqual(externalDefault, 'bar', 'external default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## esm-externals-function

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }␊
      ␊
      var externalExports = _interopDefault(require('external-cjs-exports'));␊
      var externalModuleExports = _interopDefault(require('external-cjs-module-exports'));␊
      var externalNamed = _interopDefault(require('external-esm-named'));␊
      var externalMixed = _interopDefault(require('external-esm-mixed'));␊
      var externalEsmDefault = require('external-esm-default');␊
      ␊
      t.deepEqual(externalExports, { foo: 'foo' }, 'external exports');␊
      t.deepEqual(externalModuleExports, 'bar', 'external module exports');␊
      t.deepEqual(externalNamed, { foo: 'foo' }, 'external named');␊
      t.deepEqual(externalMixed, 'bar', 'external mixed');␊
      t.deepEqual(externalEsmDefault, { default: 'bar' }, 'external default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## esm-externals-list

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }␊
      ␊
      var externalExports = _interopDefault(require('external-cjs-exports'));␊
      var externalModuleExports = _interopDefault(require('external-cjs-module-exports'));␊
      var externalNamed = _interopDefault(require('external-esm-named'));␊
      var externalMixed = _interopDefault(require('external-esm-mixed'));␊
      var externalEsmDefault = require('external-esm-default');␊
      ␊
      t.deepEqual(externalExports, { foo: 'foo' }, 'external exports');␊
      t.deepEqual(externalModuleExports, 'bar', 'external module exports');␊
      t.deepEqual(externalNamed, { foo: 'foo' }, 'external named');␊
      t.deepEqual(externalMixed, 'bar', 'external mixed');␊
      t.deepEqual(externalEsmDefault, { default: 'bar' }, 'external default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## esm-externals-true

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var externalCjsExports = require('external-cjs-exports');␊
      var externalCjsModuleExports = require('external-cjs-module-exports');␊
      var externalEsmNamed = require('external-esm-named');␊
      var externalEsmMixed = require('external-esm-mixed');␊
      var externalEsmDefault = require('external-esm-default');␊
      ␊
      t.deepEqual(externalCjsExports, { foo: 'foo' }, 'external exports');␊
      t.deepEqual(externalCjsModuleExports, 'bar', 'external module exports');␊
      t.deepEqual(externalEsmNamed, { foo: 'foo' }, 'external named');␊
      t.deepEqual(externalEsmMixed, { default: 'bar', foo: 'foo' }, 'external mixed');␊
      t.deepEqual(externalEsmDefault, { default: 'bar' }, 'external default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## esm-externals-undefined

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }␊
      ␊
      var externalExports = _interopDefault(require('external-cjs-exports'));␊
      var externalModuleExports = _interopDefault(require('external-cjs-module-exports'));␊
      var externalNamed = _interopDefault(require('external-esm-named'));␊
      var externalMixed = _interopDefault(require('external-esm-mixed'));␊
      var externalDefault = _interopDefault(require('external-esm-default'));␊
      ␊
      t.deepEqual(externalExports, { foo: 'foo' }, 'external exports');␊
      t.deepEqual(externalModuleExports, 'bar', 'external module exports');␊
      t.deepEqual(externalNamed, { foo: 'foo' }, 'external named');␊
      t.deepEqual(externalMixed, 'bar', 'external mixed');␊
      t.deepEqual(externalDefault, 'bar', 'external default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## export-default-from

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var require$$0 = 'default export';␊
      ␊
      t.is(require$$0, 'default export');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## exports

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var bar = 'BAR';␊
      var baz = 'BAZ';␊
      ␊
      var foo = {␊
      	bar: bar,␊
      	baz: baz␊
      };␊
      ␊
      const { bar: bar$1 } = foo;␊
      const { baz: baz$1 } = foo;␊
      ␊
      var main = bar$1 + baz$1;␊
      ␊
      module.exports = main;␊
      `,
    }

## external-imports

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }␊
      ␊
      var foo = _interopDefault(require('foo'));␊
      ␊
      var main = foo;␊
      ␊
      module.exports = main;␊
      `,
    }

## fallback-no-default

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      /* eslint-disable */␊
      var one = 1;␊
      ␊
      var two = 2;␊
      ␊
      var foo = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	one: one,␊
      	two: two␊
      });␊
      ␊
      t.is(foo.one, 1);␊
      t.is(foo.two, 2);␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## global-not-overwritten

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      Object.defineProperty(exports, '__esModule', { value: true });␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var encode = createCommonjsModule(function (module, exports) {␊
      exports.encodeURIComponent = function() {␊
        return encodeURIComponent(this.str);␊
      };␊
      ␊
      // to ensure module is wrapped␊
      commonjsGlobal.foo = exports;␊
      });␊
      ␊
      /* eslint-disable */␊
      ␊
      const foo = {␊
        str: 'test string',␊
        encodeURIComponent: encode.encodeURIComponent␊
      };␊
      ␊
      var encoded = foo.encodeURIComponent();␊
      ␊
      exports.encoded = encoded;␊
      `,
    }

## global-var

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      /* eslint-disable */␊
      function foo() {␊
        const global = {};␊
        global.modified = true;␊
        return global;␊
      }␊
      ␊
      const notGlobal = foo();␊
      t.truthy(notGlobal.modified);␊
      t.truthy(!commonjsGlobal.modified);␊
      ␊
      var main = {};␊
      ␊
      module.exports = main;␊
      `,
    }

## import-esm-require-returns-default-auto

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var externalEsmNamed = require('external-esm-named');␊
      var externalEsmMixed = require('external-esm-mixed');␊
      var externalEsmDefault = require('external-esm-default');␊
      ␊
      const foo = 'foo';␊
      ␊
      var named = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	foo: foo␊
      });␊
      ␊
      const foo$1 = 'foo';␊
      var mixed = 'bar';␊
      ␊
      var mixed$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	foo: foo$1,␊
      	'default': mixed␊
      });␊
      ␊
      var defaultExport = 'bar';␊
      ␊
      var none = /*#__PURE__*/Object.freeze({␊
      	__proto__: null␊
      });␊
      ␊
      function getDefaultExportFromNamespaceIfNotNamed (n) {␊
      	return n && Object.prototype.hasOwnProperty.call(n, 'default') && Object.keys(n).length === 1 ? n['default'] : n;␊
      }␊
      ␊
      var externalNamed = /*@__PURE__*/getDefaultExportFromNamespaceIfNotNamed(externalEsmNamed);␊
      ␊
      var externalMixed = /*@__PURE__*/getDefaultExportFromNamespaceIfNotNamed(externalEsmMixed);␊
      ␊
      var externalDefault = /*@__PURE__*/getDefaultExportFromNamespaceIfNotNamed(externalEsmDefault);␊
      ␊
      t.deepEqual(named, { foo: 'foo' }, 'named exports');␊
      t.deepEqual(mixed$1, { foo: 'foo', default: 'bar' }, 'mixed exports');␊
      t.deepEqual(defaultExport, 'bar', 'default export');␊
      t.deepEqual(none, {}, 'no exports');␊
      t.deepEqual(externalNamed, { foo: 'foo' }, 'external named');␊
      t.deepEqual(externalMixed, { foo: 'foo', default: 'bar' }, 'external mixed');␊
      t.deepEqual(externalDefault, 'bar', 'external default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## import-esm-require-returns-default-false

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var externalEsmNamed = require('external-esm-named');␊
      var externalEsmMixed = require('external-esm-mixed');␊
      var externalEsmDefault = require('external-esm-default');␊
      ␊
      const foo = 'foo';␊
      ␊
      var named = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	foo: foo␊
      });␊
      ␊
      const foo$1 = 'foo';␊
      var mixed = 'bar';␊
      ␊
      var mixed$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	foo: foo$1,␊
      	'default': mixed␊
      });␊
      ␊
      var _default = 'bar';␊
      ␊
      var _default$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	'default': _default␊
      });␊
      ␊
      var none = /*#__PURE__*/Object.freeze({␊
      	__proto__: null␊
      });␊
      ␊
      t.deepEqual(named, { foo: 'foo' }, 'named exports');␊
      t.deepEqual(mixed$1, { foo: 'foo', default: 'bar' }, 'mixed exports');␊
      t.deepEqual(_default$1, { default: 'bar' }, 'default export');␊
      t.deepEqual(none, {}, 'no exports');␊
      t.deepEqual(externalEsmNamed, { foo: 'foo' }, 'external named');␊
      t.deepEqual(externalEsmMixed, { foo: 'foo', default: 'bar' }, 'external mixed');␊
      t.deepEqual(externalEsmDefault, { default: 'bar' }, 'external default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## import-esm-require-returns-default-function

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var dep_false_default_ = 'default';␊
      ␊
      var dep_false_default_$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	'default': dep_false_default_␊
      });␊
      ␊
      var dep_false_mixed_ = 'default'; const named = 'named';␊
      ␊
      var dep_false_mixed_$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	'default': dep_false_mixed_,␊
      	named: named␊
      });␊
      ␊
      const named$1 = 'named';␊
      ␊
      var dep_false_named_ = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	named: named$1␊
      });␊
      ␊
      var autoDefault = 'default';␊
      ␊
      var dep_auto_mixed_ = 'default'; const named$2 = 'named';␊
      ␊
      var dep_auto_mixed_$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	'default': dep_auto_mixed_,␊
      	named: named$2␊
      });␊
      ␊
      const named$3 = 'named';␊
      ␊
      var dep_auto_named_ = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	named: named$3␊
      });␊
      ␊
      var preferredDefault = 'default';␊
      ␊
      var preferredMixed = 'default';␊
      ␊
      const named$4 = 'named';␊
      ␊
      var dep_preferred_named_ = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	named: named$4␊
      });␊
      ␊
      var trueDefault = 'default';␊
      ␊
      var trueMixed = 'default';␊
      ␊
      t.deepEqual(dep_false_default_$1, { default: 'default' }, 'false default');␊
      t.deepEqual(dep_false_mixed_$1, { default: 'default', named: 'named' }, 'false mixed');␊
      t.deepEqual(dep_false_named_, { named: 'named' }, 'false named');␊
      ␊
      t.deepEqual(autoDefault, 'default', 'auto default');␊
      t.deepEqual(dep_auto_mixed_$1, { default: 'default', named: 'named' }, 'auto mixed');␊
      t.deepEqual(dep_auto_named_, { named: 'named' }, 'auto named');␊
      ␊
      t.deepEqual(preferredDefault, 'default', 'preferred default');␊
      t.deepEqual(preferredMixed, 'default', 'preferred mixed');␊
      t.deepEqual(dep_preferred_named_, { named: 'named' }, 'preferred named');␊
      ␊
      t.deepEqual(trueDefault, 'default', 'true default');␊
      t.deepEqual(trueMixed, 'default', 'true mixed');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## import-esm-require-returns-default-function-called-once

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var other = 'other.js';␊
      ␊
      var both = 'both.js';␊
      ␊
      t.deepEqual(other, 'other.js', 'other other');␊
      t.deepEqual(both, 'both.js', 'other both');␊
      ␊
      var main = 'main.js';␊
      ␊
      t.deepEqual(main, 'main.js', 'main main');␊
      t.deepEqual(both, 'both.js', 'main both');␊
      ␊
      var main_1 = {␊
      ␊
      };␊
      ␊
      module.exports = main_1;␊
      `,
    }

## import-esm-require-returns-default-function-external

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }␊
      ␊
      var externalEsmNamed = require('external-esm-named');␊
      var externalMixed = _interopDefault(require('external-esm-mixed'));␊
      var externalEsmDefault = require('external-esm-default');␊
      ␊
      function getDefaultExportFromNamespaceIfNotNamed (n) {␊
      	return n && Object.prototype.hasOwnProperty.call(n, 'default') && Object.keys(n).length === 1 ? n['default'] : n;␊
      }␊
      ␊
      var externalNamed = /*@__PURE__*/getDefaultExportFromNamespaceIfNotNamed(externalEsmNamed);␊
      ␊
      t.deepEqual(externalNamed, { foo: 'foo' }, 'named');␊
      t.deepEqual(externalMixed, 'bar', 'mixed');␊
      t.deepEqual(externalEsmDefault, { default: 'bar' }, 'default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## import-esm-require-returns-default-preferred

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var externalEsmNamed = require('external-esm-named');␊
      var externalEsmMixed = require('external-esm-mixed');␊
      var externalEsmDefault = require('external-esm-default');␊
      ␊
      const foo = 'foo';␊
      ␊
      var named = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	foo: foo␊
      });␊
      ␊
      var mixedExports = 'bar';␊
      ␊
      var defaultExport = 'bar';␊
      ␊
      var none = /*#__PURE__*/Object.freeze({␊
      	__proto__: null␊
      });␊
      ␊
      function getDefaultExportFromNamespaceIfPresent (n) {␊
      	return n && Object.prototype.hasOwnProperty.call(n, 'default') ? n['default'] : n;␊
      }␊
      ␊
      var externalNamed = /*@__PURE__*/getDefaultExportFromNamespaceIfPresent(externalEsmNamed);␊
      ␊
      var externalMixed = /*@__PURE__*/getDefaultExportFromNamespaceIfPresent(externalEsmMixed);␊
      ␊
      var externalDefault = /*@__PURE__*/getDefaultExportFromNamespaceIfPresent(externalEsmDefault);␊
      ␊
      t.deepEqual(named, { foo: 'foo' }, 'named exports');␊
      t.deepEqual(mixedExports, 'bar', 'mixed exports');␊
      t.deepEqual(defaultExport, 'bar', 'default export');␊
      t.deepEqual(none, {}, 'no exports');␊
      t.deepEqual(externalNamed, { foo: 'foo' }, 'external named');␊
      t.deepEqual(externalMixed, 'bar', 'external mixed');␊
      t.deepEqual(externalDefault, 'bar', 'external default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## import-esm-require-returns-default-true

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }␊
      ␊
      var externalNamed = _interopDefault(require('external-esm-named'));␊
      var externalMixed = _interopDefault(require('external-esm-mixed'));␊
      var externalDefault = _interopDefault(require('external-esm-default'));␊
      ␊
      var mixedExports = 'bar';␊
      ␊
      var defaultExport = 'bar';␊
      ␊
      t.deepEqual(mixedExports, 'bar', 'mixed exports');␊
      t.deepEqual(defaultExport, 'bar', 'default export');␊
      t.deepEqual(externalNamed, { foo: 'foo' }, 'external named');␊
      t.deepEqual(externalMixed, 'bar', 'external mixed');␊
      t.deepEqual(externalDefault, 'bar', 'external default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## import-esm-require-returns-default-undefined

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var externalEsmNamed = require('external-esm-named');␊
      var externalEsmMixed = require('external-esm-mixed');␊
      var externalEsmDefault = require('external-esm-default');␊
      ␊
      const foo = 'foo';␊
      ␊
      var named = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	foo: foo␊
      });␊
      ␊
      const foo$1 = 'foo';␊
      var mixed = 'bar';␊
      ␊
      var mixed$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	foo: foo$1,␊
      	'default': mixed␊
      });␊
      ␊
      var _default = 'bar';␊
      ␊
      var _default$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	'default': _default␊
      });␊
      ␊
      var none = /*#__PURE__*/Object.freeze({␊
      	__proto__: null␊
      });␊
      ␊
      t.deepEqual(named, { foo: 'foo' }, 'named exports');␊
      t.deepEqual(mixed$1, { foo: 'foo', default: 'bar' }, 'mixed exports');␊
      t.deepEqual(_default$1, { default: 'bar' }, 'default export');␊
      t.deepEqual(none, {}, 'no exports');␊
      t.deepEqual(externalEsmNamed, { foo: 'foo' }, 'external named');␊
      t.deepEqual(externalEsmMixed, { foo: 'foo', default: 'bar' }, 'external mixed');␊
      t.deepEqual(externalEsmDefault, { default: 'bar' }, 'external default');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## index

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var foo = 42;␊
      ␊
      t.is(foo, 42);␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## inline

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var multiply = function(a, b) {␊
        return a * b;␊
      };␊
      ␊
      var foo = 1;␊
      ␊
      /* eslint-disable global-require */␊
      var main = function() {␊
        return multiply(2, foo);␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## late-entry-dependency

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var other = require('./other.js');␊
      ␊
      t.is(other, 'foo');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
      'other.js': `'use strict';␊
      ␊
      var other = 'foo';␊
      ␊
      module.exports = other;␊
      `,
    }

## module_require

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var foo = 21;␊
      ␊
      var main = foo * 2;␊
      ␊
      module.exports = main;␊
      `,
    }

## named-exports

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var a = 1;␊
      var b = 2;␊
      ␊
      t.is(a, 1);␊
      t.is(b, 2);␊
      `,
    }

## named-exports-conditional

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var x = createCommonjsModule(function (module) {␊
      if (typeof someUnknownGlobal !== 'undefined') {␊
        module.exports = { named: 'bar' };␊
      } else {␊
        module.exports = { named: 'foo' };␊
      }␊
      });␊
      ␊
      t.is(x.named, 'foo');␊
      `,
    }

## named-exports-dynamic

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var x = createCommonjsModule(function (module) {␊
      window.addExport = (key, value) => {␊
        module.exports[key] = value;␊
      };␊
      });␊
      ␊
      t.is(x.named, undefined);␊
      ␊
      window.addExport('named', 'foo');␊
      ␊
      t.is(x.named, 'foo');␊
      `,
    }

## named-exports-object-define

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var x = createCommonjsModule(function (module) {␊
      Object.defineProperty(module.exports, 'named', {␊
        enumerable: true,␊
        get: function get() {␊
          return 'foo';␊
        }␊
      });␊
      });␊
      ␊
      t.is(x.named, 'foo');␊
      `,
    }

## named-exports-reexport-default

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var named = 2;␊
      ␊
      var _export = {␊
      	named: named␊
      };␊
      ␊
      var reexport = _export;␊
      ␊
      t.is(reexport.named, 2);␊
      `,
    }

## named-exports-reexport-named

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var named = 2;␊
      ␊
      var _export = {␊
      	named: named␊
      };␊
      ␊
      var named$1 = _export.named;␊
      ␊
      t.is(named$1, 2);␊
      `,
    }

## named-exports-unexported

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var named = 2;␊
      ␊
      var x = {␊
      	named: named␊
      };␊
      ␊
      t.is(x.nonExisting, undefined);␊
      `,
    }

## no-exports-entry

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var dep = 42;␊
      ␊
      t.is(dep, 42);␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## ordering

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var shared = {␊
        fooLoaded: false␊
      };␊
      ␊
      // Mutate the shared module␊
      shared.fooLoaded = true;␊
      ␊
      var bar = shared.fooLoaded;␊
      ␊
      t.truthy(bar);␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## react-apollo

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var commonjsBar = createCommonjsModule(function (module, exports) {␊
      /* eslint-disable no-underscore-dangle */␊
      function Bar() {␊
        this.x = 42;␊
      }␊
      ␊
      exports.__esModule = true;␊
      exports.default = Bar;␊
      });␊
      ␊
      var commonjsFoo = createCommonjsModule(function (module, exports) {␊
      /* eslint-disable no-underscore-dangle */␊
      ␊
      ␊
      exports.__esModule = true;␊
      exports.Bar = commonjsBar.default;␊
      });␊
      ␊
      t.is(new commonjsFoo.Bar().x, 42);␊
      `,
    }

## reassignment

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function foo() {}␊
      foo.something = false;␊
      ␊
      var foo_1 = foo;␊
      ␊
      let foo$1 = foo_1;␊
      ␊
      if (!foo$1.something) {␊
        foo$1 = function somethingElse() {};␊
        foo$1.something = true;␊
      }␊
      ␊
      t.truthy(foo$1.something);␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## require-esm-with-named-namespace

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      const foo = 'foo';␊
      var other = 'bar';␊
      ␊
      var other$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	foo: foo,␊
      	'default': other␊
      });␊
      ␊
      var dep = 'default';␊
      ␊
      var dep$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	'default': dep,␊
      	ns: other$1␊
      });␊
      ␊
      t.deepEqual(dep$1, { default: 'default', ns: { default: 'bar', foo: 'foo' } });␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## require-esm-with-namespace-and-default

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      const foo = 'foo';␊
      ␊
      var dep = 'default';␊
      ␊
      var dep$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	'default': dep,␊
      	foo: foo␊
      });␊
      ␊
      t.deepEqual(dep$1, { default: 'default', foo: 'foo' });␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## require-esm-with-namespace-named-default

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      const foo = 'foo';␊
      var other = 'bar';␊
      ␊
      var other$1 = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	foo: foo,␊
      	'default': other␊
      });␊
      ␊
      t.deepEqual(other$1, { default: 'bar', foo: 'foo' });␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## require-esm-with-namespace-prefer-default

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      const foo = 'foo';␊
      ␊
      var dep = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	foo: foo␊
      });␊
      ␊
      t.deepEqual(dep, { foo: 'foo' });␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## resolve-is-cjs-extension

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      const result = 'second';␊
      ␊
      var second = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	result: result␊
      });␊
      ␊
      t.is(second.result, 'second');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## resolve-is-cjs-filtered

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      const result = 'second';␊
      ␊
      var second = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	result: result␊
      });␊
      ␊
      t.is(second.result, 'second');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## shadowing

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function foo(require) {␊
        require('not-an-actual-require-statement');␊
      }␊
      ␊
      let result;␊
      ␊
      foo((msg) => {␊
        result = msg;␊
      });␊
      ␊
      t.is(result, 'not-an-actual-require-statement');␊
      `,
    }

## skips-dead-branches

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      commonjsGlobal.b = 2;␊
      var b = 'b';␊
      ␊
      var main =  b ;␊
      ␊
      module.exports = main;␊
      `,
    }

## this

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};␊
      ␊
      var foo = function augmentThis() {␊
        this.x = 'x';␊
      };␊
      ␊
      commonjsGlobal.y = 'y';␊
      ␊
      const obj = {};␊
      foo.call(obj);␊
      ␊
      t.is(obj.x, 'x');␊
      t.is(commonjsGlobal.y, 'y');␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## toplevel-return

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      /* eslint-disable */␊
      ␊
      ␊
      var main = 'foo';␊
      ␊
      module.exports = main;␊
      `,
    }

## toplevel-return-complex

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var foo = createCommonjsModule(function (module) {␊
      module.exports = 'bar';␊
      {␊
        return;␊
      }␊
      });␊
      ␊
      var main = foo;␊
      ␊
      module.exports = main;␊
      `,
    }

## trailing-slash

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var foo = 42;␊
      ␊
      t.is(foo, 42);␊
      ␊
      var main = {␊
      ␊
      };␊
      ␊
      module.exports = main;␊
      `,
    }

## transform-mixed-modules

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var other = 'other';␊
      ␊
      var dep = /*#__PURE__*/Object.freeze({␊
      	__proto__: null,␊
      	other: other␊
      });␊
      ␊
      t.is(other, 'other');␊
      t.deepEqual(dep, { other: 'other' });␊
      `,
    }

## transpiled-esm-default

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }␊
      ␊
      var external = _interopDefault(require('external-esm-default'));␊
      ␊
      function getDefaultExportFromCjs (x) {␊
      	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;␊
      }␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var dep = createCommonjsModule(function (module, exports) {␊
      Object.defineProperty(exports, '__esModule', { value: true });␊
      exports.default = 'default';␊
      });␊
      ␊
      var dep$1 = /*@__PURE__*/getDefaultExportFromCjs(dep);␊
      ␊
      t.is(dep$1, 'default');␊
      t.is(external, 'bar');␊
      `,
    }

## transpiled-esm-entry-default

> Snapshot 1

    {
      'entry-becd84f0.js': `'use strict';␊
      ␊
      function getDefaultExportFromCjs (x) {␊
      	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;␊
      }␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var entry = createCommonjsModule(function (module, exports) {␊
      Object.defineProperty(exports, '__esModule', { value: true });␊
      exports.default = 'default';␊
      });␊
      ␊
      var entry$1 = /*@__PURE__*/getDefaultExportFromCjs(entry);␊
      ␊
      var entry$2 = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.assign(/*#__PURE__*/Object.create(null), entry, {␊
      	'default': entry$1␊
      }));␊
      ␊
      exports.entry = entry$2;␊
      exports.entry$1 = entry$1;␊
      `,
      'entry.js': `'use strict';␊
      ␊
      var entry = require('./entry-becd84f0.js');␊
      ␊
      ␊
      ␊
      module.exports = entry.entry$1;␊
      `,
      'main.js': `'use strict';␊
      ␊
      var entry = require('./entry-becd84f0.js');␊
      ␊
      t.deepEqual(entry.entry, { default: 'default' });␊
      `,
    }

## transpiled-esm-entry-mixed

> Snapshot 1

    {
      'entry-2e56ab7c.js': `'use strict';␊
      ␊
      function getDefaultExportFromCjs (x) {␊
      	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;␊
      }␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var entry = createCommonjsModule(function (module, exports) {␊
      Object.defineProperty(exports, '__esModule', { value: true });␊
      exports.default = 'default';␊
      exports.named = 'named';␊
      });␊
      ␊
      var entry$1 = /*@__PURE__*/getDefaultExportFromCjs(entry);␊
      ␊
      var entry$2 = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.assign(/*#__PURE__*/Object.create(null), entry, {␊
      	'default': entry$1␊
      }));␊
      ␊
      exports.entry = entry$2;␊
      exports.entry$1 = entry$1;␊
      `,
      'entry.js': `'use strict';␊
      ␊
      var entry = require('./entry-2e56ab7c.js');␊
      ␊
      ␊
      ␊
      module.exports = entry.entry$1;␊
      `,
      'main.js': `'use strict';␊
      ␊
      var entry = require('./entry-2e56ab7c.js');␊
      ␊
      t.deepEqual(entry.entry, { default: 'default', named: 'named' });␊
      `,
    }

## transpiled-esm-entry-named

> Snapshot 1

    {
      'entry-00c7c97c.js': `'use strict';␊
      ␊
      function getDefaultExportFromCjs (x) {␊
      	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;␊
      }␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var entry = createCommonjsModule(function (module, exports) {␊
      Object.defineProperty(exports, '__esModule', { value: true });␊
      exports.named = 'named';␊
      });␊
      ␊
      var entry$1 = /*@__PURE__*/getDefaultExportFromCjs(entry);␊
      ␊
      var entry$2 = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.assign(/*#__PURE__*/Object.create(null), entry, {␊
      	'default': entry$1␊
      }));␊
      ␊
      exports.entry = entry$2;␊
      exports.entry$1 = entry$1;␊
      `,
      'entry.js': `'use strict';␊
      ␊
      var entry = require('./entry-00c7c97c.js');␊
      ␊
      ␊
      ␊
      module.exports = entry.entry$1;␊
      `,
      'main.js': `'use strict';␊
      ␊
      var entry = require('./entry-00c7c97c.js');␊
      ␊
      t.deepEqual(entry.entry, {␊
        // Technically, this should ideally not exist, or if we cannot avoid it due␊
        // to runtime default export detection, it should probably be undefined. We␊
        // return the namespace instead as this will fix␊
        // rollup/rollup-plugin-commonjs#224 until the remaining Rollup interop has␊
        // been updated␊
        default: { named: 'named' },␊
        named: 'named'␊
      });␊
      `,
    }

## transpiled-esm-mixed

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }␊
      ␊
      var external = require('external-esm-mixed');␊
      var external__default = _interopDefault(external);␊
      ␊
      function getDefaultExportFromCjs (x) {␊
      	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;␊
      }␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var dep = createCommonjsModule(function (module, exports) {␊
      Object.defineProperty(exports, '__esModule', { value: true });␊
      exports.named = 'named';␊
      exports.default = 'default';␊
      });␊
      ␊
      var dep$1 = /*@__PURE__*/getDefaultExportFromCjs(dep);␊
      ␊
      t.is(dep$1, 'default');␊
      t.is(dep.named, 'named');␊
      t.is(external__default, 'bar');␊
      t.is(external.foo, 'foo');␊
      `,
    }

## transpiled-esm-named

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var externalEsmNamed = require('external-esm-named');␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var dep = createCommonjsModule(function (module, exports) {␊
      Object.defineProperty(exports, '__esModule', { value: true });␊
      exports.named = 'named';␊
      });␊
      ␊
      t.is(dep.named, 'named');␊
      t.is(externalEsmNamed.foo, 'foo');␊
      `,
    }

## transpiled-esm-namespace-default

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var external = require('external-esm-default');␊
      ␊
      function getDefaultExportFromCjs (x) {␊
      	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;␊
      }␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var dep = createCommonjsModule(function (module, exports) {␊
      Object.defineProperty(exports, '__esModule', { value: true });␊
      exports.default = 'default';␊
      });␊
      ␊
      var dep$1 = /*@__PURE__*/getDefaultExportFromCjs(dep);␊
      ␊
      var dep$2 = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.assign(/*#__PURE__*/Object.create(null), dep, {␊
      	'default': dep$1␊
      }));␊
      ␊
      t.deepEqual(dep$2, {␊
        default: 'default'␊
      });␊
      ␊
      t.deepEqual(external, {␊
        default: 'bar'␊
      });␊
      `,
    }

## transpiled-esm-namespace-mixed

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var external = require('external-esm-mixed');␊
      ␊
      function getDefaultExportFromCjs (x) {␊
      	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;␊
      }␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var dep = createCommonjsModule(function (module, exports) {␊
      Object.defineProperty(exports, '__esModule', { value: true });␊
      exports.named = 'named';␊
      exports.default = 'default';␊
      });␊
      ␊
      var dep$1 = /*@__PURE__*/getDefaultExportFromCjs(dep);␊
      ␊
      var dep$2 = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.assign(/*#__PURE__*/Object.create(null), dep, {␊
      	'default': dep$1␊
      }));␊
      ␊
      t.deepEqual(dep$2, {␊
        default: 'default',␊
        named: 'named'␊
      });␊
      ␊
      t.deepEqual(external, {␊
        default: 'bar',␊
        foo: 'foo'␊
      });␊
      `,
    }

## transpiled-esm-namespace-named

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      var external = require('external-esm-named');␊
      ␊
      function getDefaultExportFromCjs (x) {␊
      	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;␊
      }␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var dep = createCommonjsModule(function (module, exports) {␊
      Object.defineProperty(exports, '__esModule', { value: true });␊
      exports.named = 'named';␊
      });␊
      ␊
      var dep$1 = /*@__PURE__*/getDefaultExportFromCjs(dep);␊
      ␊
      var dep$2 = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.assign(/*#__PURE__*/Object.create(null), dep, {␊
      	'default': dep$1␊
      }));␊
      ␊
      t.deepEqual(dep$2, {␊
        named: 'named',␊
        // Technically, this should ideally not exist, or if we cannot avoid it due␊
        // to runtime default export detection, it should probably be undefined. We␊
        // return the namespace instead as this will fix␊
        // rollup/rollup-plugin-commonjs#224 until the remaining Rollup interop has␊
        // been updated␊
        default: { named: 'named' }␊
      });␊
      ␊
      t.deepEqual(external, {␊
        foo: 'foo'␊
      });␊
      `,
    }

## typeof-module-require

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var foo = createCommonjsModule(function (module) {␊
      if (typeof module.require === 'function' && module.require) {␊
        module.exports = 1;␊
      } else {␊
        module.exports = 2;␊
      }␊
      });␊
      ␊
      t.is(foo, 1);␊
      `,
    }

## typeof-require

> Snapshot 1

    {
      'main.js': `'use strict';␊
      ␊
      function createCommonjsModule(fn, basedir, module) {␊
      	return module = {␊
      	  path: basedir,␊
      	  exports: {},␊
      	  require: function (path, base) {␊
            return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);␊
          }␊
      	}, fn(module, module.exports), module.exports;␊
      }␊
      ␊
      function commonjsRequire () {␊
      	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');␊
      }␊
      ␊
      var foo = createCommonjsModule(function (module) {␊
      if (typeof commonjsRequire === 'function' && commonjsRequire) {␊
        module.exports = 1;␊
      } else {␊
        module.exports = 2;␊
      }␊
      });␊
      ␊
      t.is(foo, 1);␊
      `,
    }
